DEFINT A-Z
'/======================SCREEN SWITCHING===================================
DECLARE SUB RelInitText ()
DECLARE SUB RelInitVGA13 ()
DECLARE SUB RelWait ()
DECLARE SUB RelDelay (BYVAL Msec%)
'/======================SCREEN BUFFER======================================
DECLARE SUB RelPCopy (BYVAL DESTSEG%, BYVAL SrcSeg%)
DECLARE SUB RelPcopyTrans (BYVAL DESTSEG%, BYVAL SrcSeg%)
DECLARE SUB RelPcopyTransB (BYVAL DESTSEG%, BYVAL SrcSeg%)
DECLARE SUB RelPcopyBlended (BYVAL DESTSEG%, BYVAL SrcSeg%)
DECLARE SUB RelPCopySF (BYVAL DESTSEG%, BYVAL SrcSeg%)
DECLARE SUB RelPCopyGamma (BYVAL DESTSEG%, BYVAL SrcSeg%, BYVAL GammaVal%)
DECLARE SUB RelCompress (BYVAL DESTSEG%, BYVAL DestOff%, BYVAL SrcSeg%)
DECLARE SUB RelXCompress (BYVAL DESTSEG%, BYVAL DestOff%, BYVAL SrcSeg%, BYVAL SrcOff%, BYVAL PERCENT%)
DECLARE SUB RelCLS (BYVAL DESTSEG%, BYVAL C%)
DECLARE SUB RelPageSwap (BYVAL DESTSEG%, BYVAL SrcSeg%)
DECLARE SUB RelCopyLineH (BYVAL DESTSEG%, BYVAL SrcSeg%, BYVAL Ypos%)
DECLARE SUB RelCopyLineV (BYVAL DESTSEG%, BYVAL SrcSeg%, BYVAL Xpos%)
DECLARE SUB RelCopyBlock (BYVAL DESTSEG%, BYVAL SrcSeg%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%)
DECLARE SUB RelGammaBlock (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL GammaVal%)
'/======================DRAWING PRIMITIVES=================================
DECLARE SUB RelPset (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL C%)
DECLARE SUB RelPsetF (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL C%)
DECLARE SUB RelPsetTrans (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL C%)
DECLARE SUB RelBoxF (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL C%)
DECLARE SUB RelBoxTransF (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL C%)
DECLARE SUB RelBoxTrans (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL C%)
DECLARE SUB RelBox (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL C%)
DECLARE SUB RelLine (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL C%)
DECLARE SUB RelLineTrans (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL C%)
DECLARE SUB RelLineH (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL C%)
DECLARE SUB RelLineV (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL Y2%, BYVAL C%)
DECLARE SUB RelLineTransV (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL Y2%, BYVAL C%)
DECLARE SUB RelLineTransH (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL C%)
'/======================SPRITE=============================================
DECLARE SUB RelSprite (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL SPRITESEGMENT%, BYVAL SPRITEOFFSET%)
DECLARE SUB RelSpriteSolid (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL SPRITESEGMENT%, BYVAL SPRITEOFFSET%)
DECLARE SUB RelSpriteFast (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL SPRITESEGMENT%, BYVAL SPRITEOFFSET%)
DECLARE SUB RelSpriteTrans (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL SPRITESEGMENT%, BYVAL SPRITEOFFSET%)
DECLARE SUB RelSpriteSF (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL SPRITESEGMENT%, BYVAL SPRITEOFFSET%)
DECLARE SUB RelSpriteColor (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL SPRITESEGMENT%, BYVAL SPRITEOFFSET%, BYVAL C%)
DECLARE SUB RelSpriteColorX (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL SPRITESEGMENT%, BYVAL SPRITEOFFSET%, BYVAL C%, BYVAL STARTC%)
DECLARE SUB RelSpriteSolidX (BYVAL DESTSEG%, BYVAL SrcSeg%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL NewX%, BYVAL NewY%)
DECLARE SUB RelSpriteGamma (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL SPRITESEGMENT%, BYVAL SPRITEOFFSET%, BYVAL GammaVal%)
DECLARE SUB RelSpriteRotate (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL ANGLE%, BYVAL SPRSEG%, BYVAL SPROFF%)
DECLARE SUB RelSpriteRotateTrans (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL ANGLE%, BYVAL SPRSEG%, BYVAL SPROFF%)
DECLARE SUB RelGet (BYVAL DESTSEG%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL SPRSEG%, BYVAL SPROFF%)
'/======================COLLISION DETECTION=================================
DECLARE FUNCTION RelCollide% (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%, BYVAL SPRITESEGMENT%, BYVAL SPRITEOFFSET%)
DECLARE FUNCTION RelCollideSpr% (BYVAL SPR1X%, BYVAL SPR1Y%, BYVAL SPR1SEGMENT%, BYVAL SPR1OFFSET%, BYVAL SPR2X%, BYVAL SPR2Y%, BYVAL SPR2SEGMENT%, BYVAL SPR2OFFSET%)
DECLARE FUNCTION RelCollideSprB% (BYVAL SPR1X%, BYVAL SPR1Y%, BYVAL SPR1SEGMENT%, BYVAL SPR1OFFSET%, BYVAL SPR2X%, BYVAL SPR2Y%, BYVAL SPR2SEGMENT%, BYVAL SPR2OFFSET%)
'/======================KEYBOARD============================================
DECLARE SUB RelKeyBoardON ()
DECLARE SUB RelKeyBoardOFF ()
DECLARE FUNCTION RelKey% (BYVAL Scancode%)
'/======================FONT================================================
DECLARE SUB RelPrint (DESTSEG%, X%, Y%, Font$, Mincolor%, Italic%)
DECLARE SUB RelPrintS (DESTSEG%, X%, Y%, Font$, Mincolor%, Xscale%, Yscale%, Italic%)
DECLARE SUB RelPrintTransS (DESTSEG%, X%, Y%, Font$, Mincolor%, Xscale%, Yscale%, Italic%)
DECLARE SUB RelScoreTrans256 (DESTSEG%, X%, Y%, Score&, Centered%, FontArray%(), FontArrayIndex%())
DECLARE SUB RelScore256 (DESTSEG%, X%, Y%, Score&, Centered%, FontArray%(), FontArrayIndex%())
DECLARE SUB RelFontFixedT256 (DESTSEG%, X%, Y%, Text$, Centered%, FontArray%(), FontArrayIndex%())
DECLARE SUB RelFontFixed256 (DESTSEG%, X%, Y%, Text$, Centered%, FontArray%(), FontArrayIndex%())
DECLARE SUB RelFontTrans256 (DESTSEG%, X%, Y%, Text$, Centered%, FontArray%(), FontArrayIndex%())
DECLARE SUB RelFont256 (DESTSEG%, X%, Y%, Text$, Centered%, FontArray%(), FontArrayIndex%())
'/======================MEMORY==============================================
DECLARE SUB RelMemCopy (BYVAL DESTSEG%, BYVAL DestOff%, BYVAL SrcSeg%, BYVAL SrcOff%, BYVAL NumBytes%)
DECLARE SUB RelAddHI (BYVAL SEGINTVAL%, BYVAL OFFINTVAL%, BYVAL BYTEVAL%)
DECLARE SUB RelAddLOW (BYVAL SEGINTVAL%, BYVAL OFFINTVAL%, BYVAL BYTEVAL%)
DECLARE FUNCTION RelGetHI (BYVAL Intval%)
DECLARE FUNCTION RelGetLow (BYVAL Intval%)
'/======================MOUSE===============================================
DECLARE SUB RelMouseShow ()
DECLARE SUB RelMouseHide ()
DECLARE SUB RelMouseReset ()
DECLARE SUB RelMouseLimitXY (BYVAL MinX%, BYVAL MinY%, BYVAL MaxX%, BYVAL MaxY%)
DECLARE SUB RelMouseSetXY (BYVAL X%, BYVAL Y%)
DECLARE FUNCTION RelMouseX% ()
DECLARE FUNCTION RelMouseY% ()
DECLARE FUNCTION RelMouseClick% ()
DECLARE FUNCTION RelMouseDetect% ()
DECLARE FUNCTION RelMouseInside (BYVAL MinX%, BYVAL MinY%, BYVAL MaxX%, BYVAL MaxY%)
'/======================IMAGES==============================================
DECLARE SUB RelLoadBMP (DESTSEG%, File$, SwitchPal%, Pall$)
'/======================PALETTES============================================
DECLARE SUB RelReadRGB (ColorVal%, R%, G%, B%)
DECLARE SUB RelWriteRGB (ColorNum%, R%, G%, B%)
DECLARE SUB RelReadPal (PalString$)
DECLARE SUB RelFade (R%, G%, B%, Counts%)
DECLARE SUB RelFadeStep (StartCol%, EndCol%, R%, G%, B%)
DECLARE SUB RelFadeToPal (PalString$, Counts%)
DECLARE SUB RelFadeToPalStep (StartCol%, EndCol%, PalString$)
DECLARE SUB RelFadeToPalX (StartCol%, EndCol%, PalString$, Counts%)
DECLARE SUB RelFadeX (StartCol%, EndCol%, R%, G%, B%, Counts%)
DECLARE SUB RelLoadPal (File$, PalString$, Switch%)
DECLARE SUB RelLoadPalPP256 (File$)
DECLARE SUB RelNegativePal ()
DECLARE SUB RelRotatePalB (StartCol%, EndCol%)
DECLARE SUB RelRotatePalF (StartCol%, EndCol%)
DECLARE SUB RelSavePal (File$)
DECLARE SUB RelSwitchToPal (PalString$)

'/======================OnSprite SUBS/FUNCTION==============================
'Special procedures Allegro Style!!! Joakim's subs :*)
DECLARE SUB RelPsetOnSprite (BYVAL DESTSprSEG%, BYVAL DESTSprOFF%, BYVAL X%, BYVAL Y%, BYVAL C%)
DECLARE SUB RelPsetOnSpriteT (BYVAL DESTSprSEG%, BYVAL DESTSprOFF%, BYVAL X%, BYVAL Y%, BYVAL C%)
DECLARE SUB RelSpriteOnSprite (BYVAL DESTSprSEG%, BYVAL DESTSprOFF%, BYVAL X%, BYVAL Y%, BYVAL SPRSEG%, BYVAL SPROFF%)
DECLARE SUB RelSpriteOnSpriteS (BYVAL DESTSprSEG%, BYVAL DESTSprOFF%, BYVAL X%, BYVAL Y%, BYVAL SPRSEG%, BYVAL SPROFF%)
DECLARE FUNCTION RelPointOnSprite% (BYVAL DESTSprSEG%, BYVAL DESTSprOFF%, BYVAL X%, BYVAL Y%)

'/======================FUNCTIONS===========================================
DECLARE FUNCTION RelSize% (BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%)
DECLARE FUNCTION RelPoint% (BYVAL DESTSEG%, BYVAL X%, BYVAL Y%)
DECLARE FUNCTION RelInside% (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%)
DECLARE FUNCTION RelInsideC% (BYVAL X%, BYVAL Y%, BYVAL XC%, BYVAL YC%, BYVAL Radius%)
'/======================CONSTANTS===========================================
'KEY CONSTANTS
CONST KEYESC = 1, KEYENTER = 28, KEYSPACE = 57, KEYTAB = &HF
CONST KEYUP = 72, KEYDOWN = 80, KEYLEFT = 75, KEYRIGHT = 77

'Of course!!!!! :)
CONST FALSE = 0, TRUE = NOT FALSE
CONST VIDEO = &HA000




